<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="README_8doxygen_8md" kind="file" language="Markdown">
    <compoundname>README.doxygen.md</compoundname>
    <briefdescription>
    </briefdescription>
    <detaileddescription>
    </detaileddescription>
    <programlisting>
<codeline><highlight class="normal">#<sp />Hardware<sp />Abstraction<sp />Layer</highlight></codeline>
<codeline />
<codeline><highlight class="normal">##<sp />Overview</highlight></codeline>
<codeline />
<codeline><highlight class="normal">The<sp />Hardware<sp />Abstraction<sp />Layer<sp />(HAL)<sp />provides<sp />a<sp />high-level<sp />interface<sp />to<sp />configure<sp />and<sp />use<sp />hardware<sp />blocks<sp />on<sp />PSoC<sp />MCUs.<sp />It<sp />is<sp />a<sp />generic<sp />interface<sp />that<sp />can<sp />be<sp />used<sp />across<sp />multiple<sp />product<sp />families.<sp />The<sp />focus<sp />on<sp />ease-of-use<sp />and<sp />portability<sp />means<sp />the<sp />HAL<sp />does<sp />not<sp />expose<sp />all<sp />of<sp />the<sp />low-level<sp />peripheral<sp />functionality.<sp />The<sp />HAL<sp />can<sp />be<sp />combined<sp />with<sp />platform-specific<sp />libraries<sp />(such<sp />as<sp />the<sp />PSoC<sp />4/6<sp />Peripheral<sp />Driver<sp />Library<sp />(PDL))<sp />within<sp />a<sp />single<sp />application.<sp />You<sp />can<sp />leverage<sp />the<sp />HAL's<sp />simpler<sp />and<sp />more<sp />generic<sp />interface<sp />for<sp />most<sp />of<sp />an<sp />application,<sp />even<sp />if<sp />one<sp />portion<sp />requires<sp />finer-grained<sp />control.</highlight></codeline>
<codeline />
<codeline><highlight class="normal">To<sp />use<sp />code<sp />from<sp />the<sp />HAL,<sp />the<sp />specific<sp />driver<sp />header<sp />file<sp />can<sp />be<sp />included<sp />or<sp />the<sp />top<sp />level<sp />`cyhal.h`<sp />header<sp />can<sp />be<sp />include<sp />to<sp />allow<sp />access<sp />to<sp />any<sp />driver.</highlight></codeline>
<codeline />
<codeline><highlight class="normal">##<sp />API<sp />Structure</highlight></codeline>
<codeline><highlight class="normal">The<sp />API<sp />functions<sp />for<sp />each<sp />HAL<sp />driver<sp />can<sp />be<sp />divided<sp />into<sp />the<sp />following<sp />categories:</highlight></codeline>
<codeline><highlight class="normal">*<sp />A<sp />`_init`<sp />function<sp />allocates<sp />a<sp />block<sp />(along<sp />with<sp />any<sp />dependent<sp />resources),<sp />configures<sp />it,<sp />and<sp />enables<sp />it.</highlight></codeline>
<codeline><highlight class="normal">*<sp />A<sp />`_free`<sp />function<sp />disables<sp />a<sp />block,<sp />releases<sp />any<sp />dependent<sp />resources,<sp />and<sp />marks<sp />it<sp />as<sp />unused.</highlight></codeline>
<codeline><highlight class="normal">*<sp />Additional<sp />functions<sp />provide<sp />access<sp />to<sp />block-specific<sp />functionality<sp />and,<sp />in<sp />some<sp />cases,<sp />manipulate<sp />a<sp />block's<sp />configuration<sp />after<sp />it<sp />has<sp />been<sp />initialized.</highlight></codeline>
<codeline />
<codeline><highlight class="normal">The<sp />`_init`<sp />API<sp />functions<sp />require<sp />a<sp />pointer<sp />to<sp />an<sp />instance<sp />of<sp />a<sp />driver-specific<sp />type<sp />(for<sp />example,<sp />`cyhal_uart_t`).<sp />This<sp />instance<sp />must<sp />be<sp />allocated<sp />by<sp />the<sp />application<sp />code<sp />and<sp />passed<sp />via<sp />pointer<sp />into<sp />the<sp />initialization<sp />function,<sp />which<sp />will<sp />populate<sp />its<sp />contents<sp />(this<sp />structure<sp />enables<sp />the<sp />HAL<sp />to<sp />avoid<sp />performing<sp />any<sp />dynamic<sp />memory<sp />allocation).<sp />From<sp />an<sp />application<sp />point<sp />of<sp />view,<sp />these<sp />structs<sp />function<sp />as<sp />an<sp />opaque<sp />handle.<sp />The<sp />same<sp />object<sp />must<sp />be<sp />passed<sp />to<sp />all<sp />subsequent<sp />API<sp />calls<sp />that<sp />operate<sp />on<sp />the<sp />same<sp />hardware<sp />instance.<sp />The<sp />struct<sp />definitions<sp />are<sp />defined<sp />within<sp />the<sp />platform-specific<sp />HAL<sp />implementation.<sp />Application<sp />code<sp />should<sp />not<sp />rely<sp />on<sp />the<sp />specific<sp />contents,<sp />which<sp />is<sp />an<sp />implementation<sp />detail<sp />and<sp />is<sp />subject<sp />to<sp />change<sp />between<sp />platforms<sp />and/or<sp />HAL<sp />releases.</highlight></codeline>
<codeline />
<codeline><highlight class="normal">Many<sp />`_init`<sp />functions<sp />also<sp />have<sp />an<sp />argument<sp />for<sp />a<sp />pointer<sp />to<sp />a<sp />`cyhal_clock_t`<sp />instance.<sp />This<sp />is<sp />an<sp />optional<sp />argument<sp />to<sp />enable<sp />sharing<sp />of<sp />clock<sp />dividers<sp />in<sp />large<sp />designs<sp />(via<sp />using<sp />`cyhal_clock_init`<sp />or<sp />`cyhal_clock_allocate`<sp />to<sp />allocate<sp />a<sp />shared<sp />divider).<sp />If<sp />a<sp />`NULL`<sp />value<sp />is<sp />passed,<sp />the<sp />init<sp />function<sp />will<sp />allocate<sp />a<sp />clock<sp />divider<sp />that<sp />is<sp />exclusive<sp />to<sp />that<sp />block<sp />instance.</highlight></codeline>
<codeline />
<codeline><highlight class="normal">Note:<sp />Some<sp />APIs<sp />that<sp />manipulate<sp />block<sp />timing<sp />may<sp />not<sp />be<sp />able<sp />to<sp />support<sp />as<sp />wide<sp />of<sp />a<sp />range<sp />of<sp />values<sp />when<sp />using<sp />a<sp />shared<sp />divider.<sp />When<sp />a<sp />divider<sp />is<sp />shared<sp />the<sp />driver<sp />cannot<sp />unilaterally<sp />change<sp />the<sp />divider's<sp />value<sp />because<sp />that<sp />would<sp />affect<sp />other<sp />divider<sp />clients.<sp />This<sp />is<sp />not<sp />an<sp />issue<sp />with<sp />a<sp />dedicated<sp />divider.</highlight></codeline>
<codeline />
<codeline><highlight class="normal">##<sp />Resource<sp />Identification</highlight></codeline>
<codeline><highlight class="normal">For<sp />peripherals,<sp />the<sp />HAL<sp />generally<sp />does<sp />not<sp />identify<sp />block<sp />instances<sp />directly<sp />(for<sp />example,<sp />by<sp />index).<sp />Instead,<sp />block<sp />instances<sp />are<sp />identified<sp />indirectly<sp />by<sp />specifying<sp />the<sp />desired<sp />pin<sp />for<sp />each<sp />function.<sp />The<sp />`_init`<sp />function<sp />selects<sp />the<sp />block<sp />instance<sp />that<sp />connects<sp />to<sp />the<sp />specified<sp />pins.<sp />If<sp />multiple<sp />block<sp />instances<sp />can<sp />connect<sp />to<sp />the<sp />specified<sp />pins,<sp />the<sp />HAL<sp />may<sp />select<sp />any<sp />available<sp />instance.</highlight></codeline>
<codeline />
<codeline><highlight class="normal">##<sp />Hardware<sp />Manager</highlight></codeline>
<codeline><highlight class="normal">To<sp />ensure<sp />that<sp />distinct<sp />driver<sp />instances<sp />do<sp />not<sp />attempt<sp />to<sp />manipulate<sp />the<sp />same<sp />hardware<sp />blocks,<sp />the<sp />HAL<sp />includes<sp />facilities<sp />for<sp />allocating<sp />and<sp />tracking<sp />resource<sp />use.<sp />The<sp />"Hardware<sp />Manager"<sp />component<sp />handles<sp />this.<sp />It<sp />is<sp />usually<sp />not<sp />necessary<sp />to<sp />interact<sp />directly<sp />with<sp />the<sp />Hardware<sp />Manager<sp />from<sp />application<sp />firmware.<sp />The<sp />peripheral<sp />drivers<sp />automatically<sp />reserve<sp />the<sp />resources<sp />they<sp />require<sp />(and<sp />check<sp />for<sp />conflicts)<sp />as<sp />part<sp />of<sp />the<sp />`_init`<sp />API.<sp />However,<sp />the<sp />Hardware<sp />Manager<sp />is<sp />part<sp />of<sp />the<sp />public<sp />HAL<sp />API,<sp />and<sp />the<sp />application<sp />may<sp />directly<sp />invoke<sp />it<sp />to<sp />handle<sp />advanced<sp />use<sp />cases.<sp />For<sp />example,<sp />if<sp />a<sp />block<sp />instance<sp />will<sp />be<sp />managed<sp />by<sp />a<sp />lower-level<sp />API<sp />(for<sp />example,<sp />PSoC<sp />4/6<sp />PDL),<sp />the<sp />application<sp />should<sp />call<sp />the<sp />`cyhal_hwmgr_reserve`<sp />function<sp />to<sp />ensure<sp />that<sp />no<sp />other<sp />HAL<sp />driver<sp />attempts<sp />to<sp />use<sp />the<sp />same<sp />block.</highlight></codeline>
<codeline />
<codeline><highlight class="normal">##<sp />Power<sp />Management</highlight></codeline>
<codeline><highlight class="normal">The<sp />System<sp />driver<sp />provides<sp />general<sp />purpose<sp />power<sp />management<sp />APIs<sp />(`cyhal_system_register_callback`<sp />and<sp />`cyhal_system_unregister_callback`)<sp />that<sp />can<sp />be<sp />used<sp />to<sp />control<sp />when<sp />the<sp />application<sp />can<sp />go<sp />to<sp />sleep<sp />at<sp />a<sp />global<sp />level.<sp />Additionally,<sp />each<sp />peripheral<sp />driver<sp />has<sp />its<sp />own<sp />default<sp />power<sp />management<sp />strategy.<sp />The<sp />strategy<sp />is:</highlight></codeline>
<codeline><highlight class="normal">*<sp />Peripherals<sp />that<sp />can<sp />operate<sp />as<sp />is<sp />in<sp />the<sp />requested<sp />lower<sp />power<sp />mode<sp />do<sp />so</highlight></codeline>
<codeline><highlight class="normal">*<sp />Peripherals<sp />that<sp />are<sp />purely<sp />input<sp />allow<sp />the<sp />lower<sp />power<sp />mode<sp />transition,<sp />but<sp />make<sp />sure<sp />they<sp />restore<sp />there<sp />state<sp />(if<sp />needed)<sp />when<sp />exiting<sp />the<sp />low<sp />power<sp />mode</highlight></codeline>
<codeline><highlight class="normal">*<sp />Peripherals<sp />that<sp />are<sp />actively<sp />outputting<sp />a<sp />signal,<sp />but<sp />cannot<sp />do<sp />so<sp />in<sp />the<sp />requested<sp />power<sp />mode,<sp />block<sp />the<sp />transition</highlight></codeline>
<codeline><highlight class="normal">*<sp />Peripherals<sp />that<sp />can<sp />output<sp />a<sp />signal,<sp />but<sp />are<sp />not<sp />currently,<sp />will<sp />allow<sp />the<sp />lower<sp />power<sp />mode<sp />transition,<sp />and<sp />restore<sp />state<sp />when<sp />it<sp />comes<sp />back</highlight></codeline>
<codeline />
<codeline><highlight class="normal">Additionally,<sp />all<sp />peripherals<sp />provide<sp />a<sp />function<sp />(`cyhal_&lt;peripheral&gt;_set_power_mode_strategy`)<sp />that<sp />allows<sp />changing<sp />this<sp />behavior.<sp />There<sp />are<sp />three<sp />possible<sp />modes:<sp />Default,<sp />Allow,<sp />and<sp />Custom.<sp />Default<sp />does<sp />what<sp />is<sp />described<sp />above<sp />and<sp />what<sp />all<sp />peripherals<sp />do<sp />unless<sp />overridden.<sp />Allow<sp />causes<sp />the<sp />peripheral<sp />to<sp />always<sp />accept<sp />the<sp />low<sp />power<sp />transition<sp />independent<sp />of<sp />what<sp />it<sp />is<sp />currently<sp />doing.<sp />When<sp />the<sp />power<sp />mode<sp />exits,<sp />it<sp />will<sp />attempt<sp />to<sp />resume<sp />its<sp />previous<sp />activity.<sp />Custom<sp />causes<sp />the<sp />driver<sp />to<sp />call<sp />the<sp />callback<sp />function<sp />provided<sp />in<sp />`cyhal_system_set_power_custom_callback`<sp />to<sp />allow<sp />the<sp />application<sp />to<sp />specify<sp />what<sp />to<sp />do<sp />in<sp />the<sp />case<sp />the<sp />peripheral<sp />is<sp />currently<sp />running,<sp />but<sp />cannot<sp />operate<sp />in<sp />the<sp />new<sp />mode.</highlight></codeline>
<codeline />
<codeline><highlight class="normal">##<sp />Compile<sp />Time<sp />Dependencies</highlight></codeline>
<codeline><highlight class="normal">The<sp />HAL<sp />public<sp />interface<sp />is<sp />consistent<sp />across<sp />all<sp />platforms<sp />that<sp />the<sp />HAL<sp />supports.<sp />However,<sp />the<sp />HAL<sp />interface<sp />does<sp />depend<sp />on<sp />types<sp />that<sp />are<sp />defined<sp />by<sp />platform-specific<sp />HAL<sp />implementations<sp />(for<sp />example,<sp />the<sp />driver-specific<sp />"handle"<sp />types).<sp />Additionally,<sp />a<sp />HAL<sp />implementation<sp />may<sp />be<sp />compile-time<sp />dependent<sp />on<sp />device-specific<sp />data<sp />structures<sp />(for<sp />example,<sp />mapping<sp />pins<sp />to<sp />peripheral<sp />instances).<sp />This<sp />means<sp />that<sp />in<sp />order<sp />to<sp />compile<sp />an<sp />application<sp />that<sp />depends<sp />on<sp />the<sp />HAL,<sp />it<sp />must<sp />build<sp />against<sp />a<sp />platform-specific<sp />implementation<sp />of<sp />the<sp />HAL,<sp />specifying<sp />a<sp />particular<sp />device.<sp />The<sp />resulting<sp />application<sp />will<sp />be<sp />source<sp />(but<sp />not<sp />binary)<sp />compatible<sp />with<sp />a<sp />HAL<sp />implementation<sp />for<sp />any<sp />other<sp />platform.</highlight></codeline>
<codeline />
<codeline><highlight class="normal">Some<sp />HAL<sp />driver's<sp />may<sp />have<sp />slightly<sp />different<sp />behavior<sp />when<sp />run<sp />in<sp />an<sp />RTOS<sp />environment.<sp />This<sp />is<sp />typically<sp />found<sp />in<sp />operations<sp />that<sp />need<sp />to<sp />wait<sp />for<sp />a<sp />significant<sp />period<sp />of<sp />time.<sp />In<sp />an<sp />RTOS<sp />aware<sp />environment,<sp />the<sp />function<sp />will<sp />attempt<sp />to<sp />wait<sp />using<sp />the<sp />RTOS.<sp />This<sp />allows<sp />other<sp />threads<sp />in<sp />the<sp />application<sp />to<sp />run<sp />while<sp />the<sp />current<sp />operation<sp />is<sp />waiting.<sp />In<sp />non-RTOS<sp />aware<sp />environments<sp />(eg:<sp />bare<sp />metal<sp />environments)<sp />the<sp />functions<sp />will<sp />instead<sp />rely<sp />on<sp />busy<sp />waits<sp />for<sp />operations<sp />to<sp />complete.<sp />To<sp />inform<sp />the<sp />HAL<sp />that<sp />an<sp />RTOS<sp />environment<sp />is<sp />being<sp />used<sp />the<sp />`RTOS_AWARE`<sp />component<sp />(COMPONENTS+=RTOS_AWARE)<sp />or<sp />the<sp />`CY_RTOS_AWARE`<sp />define<sp />(DEFINES+=CY_RTOS_AWARE)<sp />must<sp />be<sp />set.<sp />When<sp />set,<sp />the<sp />HAL<sp />will<sp />use<sp /><sp />the<sp />[RTOS<sp />Abstraction](https://github.com/cypresssemiconductorco/abstraction-rtos)<sp />APIs<sp />to<sp />wait.</highlight></codeline>
<codeline />
<codeline><highlight class="normal">##<sp />Event<sp />Handling</highlight></codeline>
<codeline><highlight class="normal">Many<sp />HAL<sp />drivers<sp />provide<sp />an<sp />API<sp />for<sp />registering<sp />a<sp />callback<sp />which<sp />is<sp />invoked<sp />when<sp />certain<sp />(driver-specific)<sp />events<sp />occur.<sp />These<sp />drivers<sp />also<sp />often<sp />provide<sp />an<sp />API<sp />for<sp />enabling<sp />or<sp />disabling<sp />specific<sp />types<sp />of<sp />events.<sp />Unless<sp />otherwise<sp />documented,<sp />the<sp />callback<sp />will<sp />only<sp />be<sp />invoked<sp />for<sp />events<sp />that<sp />occur<sp />while<sp />that<sp />event<sp />type<sp />is<sp />enabled.<sp />Specifically,<sp />events<sp />that<sp />occur<sp />while<sp />a<sp />given<sp />event<sp />type<sp />is<sp />disabled<sp />are<sp />not<sp />queued<sp />and<sp />will<sp />not<sp />trigger<sp />a<sp />callback<sp />when<sp />that<sp />event<sp />type<sp />is<sp />(re)enabled.</highlight></codeline>
<codeline />
<codeline><highlight class="normal">##<sp />Error<sp />reporting</highlight></codeline>
<codeline><highlight class="normal">The<sp />HAL<sp />uses<sp />the<sp />@ref<sp />cy_rslt_t<sp />type<sp />(from<sp />the<sp />core-lib<sp />library)<sp />in<sp />all<sp />places<sp />where<sp />a<sp />HAL<sp />function<sp />might<sp />return<sp />an<sp />error<sp />code.<sp />This<sp />provides<sp />structured<sp />error<sp />reporting<sp />and<sp />makes<sp />it<sp />easy<sp />to<sp />determine<sp />the<sp />module<sp />from<sp />which<sp />the<sp />error<sp />arose,<sp />as<sp />well<sp />as<sp />the<sp />specific<sp />error<sp />cause.<sp />Macros<sp />are<sp />provided<sp />to<sp />help<sp />extract<sp />this<sp />information<sp />from<sp />a<sp />@ref<sp />cy_rslt_t<sp />value.</highlight></codeline>
<codeline />
<codeline><highlight class="normal">The<sp />HAL<sp />driver<sp />headers<sp />provide<sp />macros<sp />corresponding<sp />to<sp />codes<sp />for<sp />common<sp />error<sp />situations.<sp />Note<sp />that<sp />the<sp />errors<sp />listed<sp />in<sp />the<sp />driver<sp />header<sp />are<sp />not<sp />a<sp />comprehensive<sp />list;<sp />in<sp />less<sp />common<sp />cases<sp />a<sp />low-level,<sp />implementation-specific<sp />error<sp />code<sp />may<sp />be<sp />returned.</highlight></codeline>
<codeline />
<codeline><highlight class="normal">For<sp />more<sp />details<sp />on<sp />interacting<sp />with<sp />@ref<sp />cy_rslt_t<sp />see<sp />[Result<sp />Type](group__group__result.html).</highlight></codeline>
<codeline />
<codeline><highlight class="normal">##<sp />More<sp />information</highlight></codeline>
<codeline><highlight class="normal">*<sp />[API<sp />Reference<sp />Guide](https://cypresssemiconductorco.github.io/mtb-hal-cat1/html/modules.html)</highlight></codeline>
<codeline><highlight class="normal">*<sp />[Cypress<sp />Semiconductor,<sp />an<sp />Infineon<sp />Technologies<sp />Company](http://www.cypress.com)</highlight></codeline>
<codeline><highlight class="normal">*<sp />[Cypress<sp />Semiconductor<sp />GitHub](https://github.com/cypresssemiconductorco)</highlight></codeline>
<codeline><highlight class="normal">*<sp />[ModusToolbox](https://www.cypress.com/products/modustoolbox-software-environment)</highlight></codeline>
<codeline />
<codeline><highlight class="normal">---</highlight></codeline>
<codeline><highlight class="normal">©<sp />Cypress<sp />Semiconductor<sp />Corporation,<sp />2019-2020.</highlight></codeline>
    </programlisting>
    <location file="hal/psoc6/README.doxygen.md" />
  </compounddef>
</doxygen>